#include <bits/stdc++.h>


using namespace std;


unsigned long long danKadPronasao[300000];
unsigned kolikoPakovanjaKupioTajDan[300000];


//long long kolikoPakovanjaImaTajDan[300000];


unsigned long long danKadCerkaPrestajeDaJede[300000];

unsigned long long odgovori[300000];
main(){
    unsigned brPutaOtacPronasaoPlazmu, brojPitanja;

    scanf("%u %u",&brPutaOtacPronasaoPlazmu,&brojPitanja);
    unsigned long long kolikoPakovanjaImaTrenDan=0;
    for(int i=0; i<brPutaOtacPronasaoPlazmu; i++){

        scanf("%llu %u",&danKadPronasao[i], &kolikoPakovanjaKupioTajDan[i]);
         //koliko zapravo ima taj dan na raspolaganju sa pretpostavkom da nikad nije jela
        //kolikoPakovanjaImaTrenDan+=kolikoPakovanjaKupioTajDan[i];

        //kolikoPakovanjaImaTajDan[i]=kolikoPakovanjaImaTrenDan;
    }

    for (int i=0;i<brojPitanja; i++){
        scanf("%llu",&danKadCerkaPrestajeDaJede[i]);
        unsigned long long pojedenoDoTogDana=0;
        unsigned long long trenStanje=0;

        for(int j=0;j<brPutaOtacPronasaoPlazmu; j++){
            trenStanje+=kolikoPakovanjaKupioTajDan[j];
            //int danPosleToga=kolikoPakovanjaImaTajDan[j+1];
            //maxPojedeno=kolikoPakovanjaImaTajDan[j+1]-kolikoPakovanjaImaTajDan[j];
            unsigned long long dan1=danKadPronasao[j];
            unsigned long long dan2;
            unsigned long long maxPojedeno;
            if(j+1==brPutaOtacPronasaoPlazmu)
                dan2=danKadCerkaPrestajeDaJede[i]+1; //]
            else
                dan2=min(danKadPronasao[j+1],danKadCerkaPrestajeDaJede[i]+1); //) ili ]


            if(dan1>danKadCerkaPrestajeDaJede[i]+1)
                break;
            maxPojedeno=dan2-dan1;
            unsigned long long pojedenoTajDan=min(trenStanje,maxPojedeno);
            pojedenoDoTogDana+=pojedenoTajDan;
            trenStanje-=pojedenoTajDan;

        }


        odgovori[i]=pojedenoDoTogDana;


        //stanjePoslednjiDan=kolikoPakovanjaImaTajDan[brPutaOtacPronasaoPlazmu-1]

    }

    for(int i=0;i<brojPitanja;i++){

        printf("%u\n",odgovori[i]);
    }




}